/*!
 * \file      app_drv_ch57x_utc_time.h
 *
 * \brief     ch57x utc time implementation
 *
 * \copyright Revised BSD License, see section \ref LICENSE.
 *
 * \code
 *
 *              (C)2002-2020 wch
 *
 * \endcode
 *
 * \author    kingsley zhang ( @wch )
 *
 */


/*  UTC started at 00:00:00 January 1, 2020 */



#include "stdint.h"
#include "utc_time.h"




#ifndef __APP_DRV_CH57X_UTC_TIME_H
#define __APP_DRV_CH57X_UTC_TIME_H




//typedef struct
//{
//  uint8_t seconds;  // 0-59
//  uint8_t minutes;  // 0-59
//  uint8_t hour;     // 0-23
//  uint8_t day;      // 0-30 //after offset 1-31
//  uint8_t month;    // 0-11 //after offset 1-12 
//  uint16_t year;    // 2020+
//} utc_time_t ;

#define app_drv_ch57x_utc_time_time_t utc_time_t




//convert timestamp to time_t
#define app_drv_ch57x_utc_time_timestamp_to_time convert_utc_time

//convert time_t to timestamp
//be careful this will not do parameters checking
#define app_drv_ch57x_utc_time_time_to_timestamp convert_utc_secs

//max seconds is (0x3fff+1)*(3600*24) - 1
uint32_t app_drv_ch57x_utc_time_get_timestamp(void);

//set local rtc cnt in second
//the max timestamp in hardware is (0x3fff+1)*(3600*24) - 1 , about 44 year
//this will cause ble connection lost
void app_drv_ch57x_utc_time_set_timestamp(uint32_t timestamp);

#endif // __APP_DRV_CH57X_UTC_TIME_H
