#ifndef TIME_H
#define TIME_H

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdint.h>

#define	IsLeapYear(yr)	(!((yr) % 400) || (((yr) % 100) && !((yr) % 4)))
// number of seconds since 0 hrs, 0 minutes, 0 seconds, on the
// 1st of January 2020 UTC
typedef uint32_t utc_time;

// To be used with
//#pragma pack(1)
typedef struct {
    uint8_t seconds;  // 0-59
    uint8_t minutes;  // 0-59
    uint8_t hour;     // 0-23
    uint8_t day;      // 0-30 //after offset 1-31
    uint8_t month;    // 0-11 //after offset 1-12 
    uint16_t year;    // 2000+
} utc_time_t ;

/*********************************************************************
 * GLOBAL VARIABLES
 */

/*********************************************************************
 * FUNCTIONS
 */

extern void convert_utc_time( utc_time_t *tm, utc_time sec_time );

/*
 * Converts UTCTimeStruct to UTCTime (seconds since 00:00:00 01/01/2000)
 *
 * tm - pointer to UTC time struct
 */
extern utc_time convert_utc_secs( utc_time_t *tm );

#ifdef __cplusplus
}
#endif

#endif
